

/*
HEUTE 24.08.2016
HEUTE 31.08.2016
https://eewiki.net/display/microcontroller/Home
//History ADDED
*/

// board support package
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// EFM32 device files
#include "em_chip.h"
#include "em_cmu.h"
#include "em_device.h"
#include "em_cmu.h"
#include "em_timer.h"
#include "em_usart.h"
#include "em_gpio.h"
//#include "em_i2c.h"

#include "./inc/InitDevice.h"  //Von Configurator erzeugt
#include "./BSP/bsp_defs.h" // UINT etc..
#include "./BSP/BSP_LoRa_V1_Board.h"	// board specific definitions
//Nutz die Funktione darin
#include  "LCD_HD44780_NoBusy.h"

///LoRa
// HCI wrapper file
#include  "CRC16.h"
#include  "iM880A_RadioInterface.h"
// needed for power-up delay
#include "./Driver/PDD/PDDDelayTimer.h"
#include "./DRIVER/PDD/PDDUsart.h"

#include "MyHeader.h"
#include "Service.h"
#include "LoRa_MSG.h"

//------------------------------------------------------------------------------
//
//	Section Typedefs
//
//------------------------------------------------------------------------------
typedef enum
{
    SEND_MSG                        = 0x0001,
    POWER_UP                        = 0x0002,
    MSG_RECEIVED                    = 0x0004,
}TMainEventCode;

//Prototypes.
static void GpioSetup( void );
//BLINK ===========================
static void Delay_MS(unsigned long ulWaitTicks);
void GPIO_Unified_IRQ(void);

//------------------------------------------------------------------------------
//
//	Section RAM
//
//------------------------------------------------------------------------------

// **********************************************
//Globals
// **********************************************
volatile uint32_t gu32TickCompare;
volatile uint32_t gu32MsTicks;
volatile uint8_t gu8Flags;
volatile uint8_t gu8RepeatModulo;
//static uint8_t gu8Interrupt_Flags;
UINT32 mainEvent = 0;
char gcaStr[ STRMAX +1 ] = {0};
char gcaNumStr[ NUMSTRMAX +1 ] = {0};
//int16_t gi16Val;
//volatile uint32_t  gu32NN;

volatile bool gpSW1Pressed, gpSW2Pressed;
//static DISPLAY_Device_t displayDevice;  // Aus Space Invaveder
TWiMODLRResult gtTWIModLRResult;

//------------------------------------------------------------------------------
//
//	Section Code
//
//------------------------------------------------------------------------------

//  *****************************
void Delay_MS(unsigned long ulWaitTicks)
//  *****************************
{
unsigned long ulCurTicks = gu32MsTicks;
while( (gu32MsTicks - ulCurTicks) <  ulWaitTicks ){};
};


//------------------------------------------------------------------------------
//
//	CbRxIndication
//
//------------------------------------------------------------------------------
static void
CbRxIndication     (UINT8*          rxMsg,
                    UINT8           length,
                    TRadioFlags     rxFlags)
{
    if(rxFlags == trx_RXDone)
    {
        mainEvent |= MSG_RECEIVED;  // Radio Msg received
    }
}

//------------------------------------------------------------------------------
//
//	CbTxIndication
//
//------------------------------------------------------------------------------
static void
CbTxIndication     (TRadioMsg*     txMsg,
                    TRadioFlags     txFlags)
{
    if(txFlags == trx_TXDone)
    {
        // TX was successfull
    	LCD_PrintStr( "TX-OK ! ", MSG_YLINE );
    }
    else
    {   
        //  error
    }
};

//------------------------------------------------------------------------------
//
//	System_Setup
//
//------------------------------------------------------------------------------
//!
//! @brief: Top Level Setup routine
//!
//------------------------------------------------------------------------------

/**************************************************************************//**
 * @brief SysTick_Handler
 * Interrupt Service Routine for system tick counter
 *****************************************************************************/
void SysTick_Handler(void)
{
	gu32MsTicks++;       /* increment counter necessary in Delay()*/
	if( (gu32MsTicks - gu32TickCompare) >= 1000)
		{
		gu32TickCompare = gu32MsTicks;
		gu8Flags |= TICK_1S_EVENT;
		};
};


/**************************************************************************//**
 * @brief Delays number of msTick Systicks (typically 1 ms)
 * @param dlyTicks Number of ticks to delay
 *****************************************************************************/

//  **************************************************************************
//Setup GPIO interrupt for pushbuttons.
// **************************************************************************
static void GpioSetup( void )
{
  /* Enable GPIO clock. */
	//CMSIS
  CMU_ClockEnable( cmuClock_GPIO, true );


  // Configure SW1 as input and enable interrupt
  GPIO_PinModeSet(BSP_GPIO_SW1_PORT, BSP_GPIO_SW1_PIN, gpioModeInputPull, 1);
  GPIO_IntConfig(BSP_GPIO_SW1_PORT, BSP_GPIO_SW1_PIN, false, true, true);  //INT Falling Edge

  // Configure SW2 as input and enable interrupt
  //GPIO_Mode_TypeDef mode
  GPIO_PinModeSet(BSP_GPIO_SW2_PORT, BSP_GPIO_SW2_PIN, gpioModeInputPull, 1);
  GPIO_IntConfig(BSP_GPIO_SW2_PORT, BSP_GPIO_SW2_PIN, false, true, true);  //Int Falling Edge

  // OUTPUTS
  GPIO_PinModeSet( LED1_PORT ,  LED1_PIN, gpioModePushPullDrive , 0);
  GPIO_PinModeSet( LED2_PORT ,  LED2_PIN, gpioModePushPullDrive , 0);
      ////PULS
  GPIO_PinModeSet(  TOGGLE_BIT_PORT , TOGGLE_BIT_PIN, gpioModePushPull , 0);

  NVIC_ClearPendingIRQ(GPIO_EVEN_IRQn);  // Anstehender Interrrupt
  NVIC_EnableIRQ(GPIO_EVEN_IRQn);

  NVIC_ClearPendingIRQ(GPIO_ODD_IRQn); // Anstehender Interrrupt
  NVIC_EnableIRQ(GPIO_ODD_IRQn);

  //TEST
  GPIO_PinOutSet( LED1_PORT,  LED1_PIN);
  GPIO_PinOutSet( LED2_PORT,  LED2_PIN);
};

/**************************************************************************//**
* @brief Unified GPIO Interrupt handler (pushbuttons)
*        PB0 Starts selected test
*        PB1 Cycles through the available tests
*****************************************************************************/
void GPIO_Unified_IRQ(void)
{
  /* Get and clear all pending GPIO interrupts */
  uint32_t interruptMask = GPIO_IntGet();
  GPIO_IntClear(interruptMask);

  /* Act on interrupts */
  if (interruptMask & (1 << BSP_GPIO_SW1_PIN))
  {
    /* PB0 */
    gpSW1Pressed = true;
  }

  if (interruptMask & (1 << BSP_GPIO_SW2_PIN))
  {
    /* PB1 */
    gpSW2Pressed = true;
  }
}


/**************************************************************************//**
* @brief GPIO Interrupt handler for even pins
*****************************************************************************/
void GPIO_EVEN_IRQHandler(void)
{
  GPIO_Unified_IRQ();
}


/**************************************************************************//**
* @brief GPIO Interrupt handler for odd pins
*****************************************************************************/
void GPIO_ODD_IRQHandler(void)
{
  GPIO_Unified_IRQ();
}

// **********************************************
void ShowTWILRResult(TWiMODLRResult tResult )
// **********************************************
{
	/*
	 * displaypalemlib.c
	 * displayls013b7dh03.c
	 *
	 * LCD_PORT_DISP_SEL
	 */
switch(tResult )
	{
	case WiMODLR_RESULT_OK:
		//printf("\n");
		LCD_PrintStr( "TWI-RESULT_OK!", 0);
		break;
	case WiMODLR_RESULT_PAYLOAD_LENGTH_ERROR:
		//printf("\nPayLLGTHErr");
		LCD_PrintStr( "PayLGTHErr", MSG_YLINE);
		break;
	case WiMODLR_RESULT_PAYLOAD_PTR_ERROR:
		//printf("\nPAYLDPTRErr");
		LCD_PrintStr( "PAYLDPTRErr",MSG_YLINE);
		break;
	case  WiMODLR_RESULT_TRANMIT_ERROR:
		//printf("\nTrnsmErr");
		LCD_PrintStr( "RESULT_TransMt_ER", MSG_YLINE);
		break;
	};//Switch
};



// MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN *
// MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN * MAIN *
int main(void)
{
uint32_t u32NN=0;
volatile uint32_t u32MainCnt=0;
volatile uint32_t u32MainCnt_Store=0;
volatile uint32_t u32MainCnt_Diff=0;

// Initialize C
/* Chip errata */
CHIP_Init();

/// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!  HIER STOPT DIE MASCHINE
//enter_DefaultMode_from_RESET();
//WARUM ???

// Init external clock
CMU_ClockSelectSet(cmuClock_HF, cmuSelect_HFXO);
CMU_ClockEnable(cmuClock_HFPER, true);
 // Initalizing System

GpioSetup();		//-->CMU_ClockEnable( cmuClock_GPIO, true );

/* Setup SysTick Timer for 1 msec interrupts  */
// Init delay timer
if (SysTick_Config(CMU_ClockFreqGet(cmuClock_CORE) / 1000)) while (1) ;
PDDDelayTimer_Setup();

//CMSIS
lcd_init(LCD_DISP_ON);
lcd_clrscr();
LCD_PrintStr( "LoRaV1.0", MSG_YLINE );
//LoRA
iM880A_Init();

// Register callback functions for receive / send
iM880A_RegisterRadioCallbacks(CbRxIndication, CbTxIndication);
// Wait for radio to power up
PDDDelayTimer_Delay_ms(POWERUP_DELAY);
// Set configuration parameters
iM880A_Configure();
/* Enter infinite loop */

// =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=  =/\=
while(1)
	{
	u32MainCnt++;
//Delay(250);
/*
if(gpSW1Pressed && gpSW1Pressed)
{
	gpSW1Pressed = false;
	gpSW2Pressed = false;

	gu8Flags ^= PERIODIC_TX_FLAG;
	sprintf(gcaStr, "Tgl=%d", gu8Flags & PERIODIC_TX_FLAG);
	lcd_clrscr();
	LCD_PrintStr(gcaStr, MSG_YLINE );
}
*/
	if( (gpSW1Pressed) && !(gu8Flags & SWITCH_LOCKED_FLAG) )
		{
		gu8Flags |= SWITCH_LOCKED_FLAG;
		gpSW1Pressed = false;
		lcd_clrscr();
		LCD_PrintStr( "1Pressed", MSG_YLINE );
// Toggle_Pin( BSP_Ext_OUT_PORTC, BSP_PULS_OUT);

		 gu32Msg_IDNr++;
		 sprintf( gcaPayLoadStr,"%lu=IDTx", gu32Msg_IDNr);

		 if(iM880A_SendRadioTelegram((UINT8*)gcaPayLoadStr, (UINT16)strlen(gcaPayLoadStr)) != WiMODLR_RESULT_OK)
			 {
			 LCD_PrintStr("noRES-OK", MSG_YLINE ); //"noRESULTOK"
			 }
		 else
		 	 {
			 strcpy( gcaStr, gcaPayLoadStr );
			 LCD_PrintStr(gcaPayLoadStr, DATA_YLINE); // Zeige gesendet an
		 	 };
		 Delay_MS(100);
		 gu8Flags &= ~SWITCH_LOCKED_FLAG;
		};


	if( (gpSW2Pressed) && !(gu8Flags & SWITCH_LOCKED_FLAG) )
		{
		//		gpSW1Pressed = false;
		gpSW2Pressed = false;
		gu8Flags |= SWITCH_LOCKED_FLAG;
		gu8Flags ^= PERIODIC_TX_FLAG;
		sprintf(gcaStr, "Tgl=%d", (gu8Flags & PERIODIC_TX_FLAG) );
		lcd_clrscr();
		LCD_PrintStr(gcaStr, MSG_YLINE );
		Delay_MS(100);
		gu8Flags &= ~SWITCH_LOCKED_FLAG;

		/*
//		gpSW1Pressed = false;
		lcd_clrscr();
		LCD_PrintStr( "2:Pressed", MSG_YLINE );
		gtTWIModLRResult = iM880A_PingRequest();
		ShowTWILRResult( gtTWIModLRResult  );
		LCD_PrintStr( "Ping Request", DATA_YLINE );
		gu8Flags &= ~SWITCH_LOCKED_FLAG;
		*/
		};

	// Radio telegram received?
	if(mainEvent & MSG_RECEIVED)
		{
		LCD_PrintStr( "RXed MSG", MSG_YLINE);
		mainEvent &= ~MSG_RECEIVED;

		//printf("\nlen:%d",RxMessage.Length);
		//printf("\nRx:%s",gcaShowStr); //gcaStr[RxMessage.Length] = 0;

		//ZEILE 233 FROM memcpy( gcaStr, rxBuffer + 9, RxMessage.Length);// Jrgens Schmutzcode
		// AUS i880A_Radiounterface.c
		//ZEILE 232

					//gcaShowStr[RxMessage.Length] = 0;;  //Warum RAUS ?
		LCD_PrintStr( "RXed MSG", MSG_YLINE);
		 LCD_PrintStr( gcaShowStr, DATA_YLINE);
		gu8Flags |= FREEZE_LCD_FLAG;
		};//if mainEvent & MSG_RECEIVED

// SEKUNDEN TICK
// ----------------------------------------------

	if( gu8Flags & TICK_1S_EVENT )
	  {
	  u32NN++;
	  gu8Flags &= ~TICK_1S_EVENT;
	  u32MainCnt_Diff = u32MainCnt - u32MainCnt_Store; // MCU LAST
	  u32MainCnt_Store = u32MainCnt;
	  //lcd_clrscr();
	  sprintf(gcaStr,"%lu", u32MainCnt_Diff);
	  LCD_PrintStr( gcaStr, MSG_YLINE);
	  sprintf(gcaStr,"%lu", u32NN);
	  LCD_PrintStr( gcaStr, DATA_YLINE);

// ----------------------------------------------


	  if( gu8Flags & PERIODIC_TX_FLAG)
		  {
		  gu8RepeatModulo++;
		  if( gu8RepeatModulo % 5 )
		  	  {
			  gu32Msg_IDNr++;
			  sprintf( gcaStr,"wait0=%d",(gu8RepeatModulo % 5));
			  LCD_PrintStr(gcaStr, MSG_YLINE);
		  	  }
		  else
		  	  {
			 gu32Msg_IDNr++;
			 LCD_PrintStr( "IncID-TX", MSG_YLINE );
		// Toggle_Pin( BSP_Ext_OUT_PORTC, BSP_PULS_OUT);

			 gu32Msg_IDNr++;
			 sprintf( gcaPayLoadStr,"TIN%lu",gu32Msg_IDNr); // TXID NR

			 if(iM880A_SendRadioTelegram((UINT8*)gcaPayLoadStr, (UINT16)strlen(gcaPayLoadStr)) != WiMODLR_RESULT_OK)
				 {
				 LCD_PrintStr("noRES-OK", MSG_YLINE ); //"noRESULTOK"
				 }
			 else
				{
				 LCD_PrintStr(gcaPayLoadStr, DATA_YLINE);
				};
		  	  };
		  };

	  gu8Flags ^= TOGGLE_FLAG;
	  if(gu8Flags & TOGGLE_FLAG)
		  {
		  GPIO_PinOutSet( LED1_PORT,  LED1_PIN);
		  GPIO_PinOutClear( LED2_PORT,  LED2_PIN);
		  }
	  else
		  {
		  GPIO_PinOutSet( LED2_PORT,  LED2_PIN);
		  GPIO_PinOutClear( LED1_PORT,  LED1_PIN);
		  };

	  Toggle_Test(1);
	  //gu8Flags &= ~FREEZE_LCD_FLAG;  // ETWAS PAUSE EERMGLICHEN // Nach einem Durchlauf freigeben
// ----------------------------------------------
	  }; //Tick

// ----------------------------------------------------------------------

/*
		Switch_UART(USE_LCD);
		strcpy(gcaStr, "==IM880A Tx==");
		gu16IDNr++;
		sprintf(gcaNumStr,":%d", gu16IDNr);
		strcat( gcaStr, gcaNumStr );
		strcat( gcaStr, "_*_" );
		gui16Val = strlen( gcaStr ); //LENGTH
		Switch_UART(USE_IM880);
		if(iM880A_SendRadioTelegram( (UINT8*)gcaStr, gui16Val ) != WiMODLR_RESULT_OK)
			{
			strcpy(gcaStr,"TxError");
			Switch_UART(USE_LCD);
			printf("\n%s",gcaStr );
			Switch_UART(USE_IM880);
			}; // handle faults
*/
	Toggle_Test(1);
	};// while
}; //main
