

/*
Stand 18.06.2017 *
*ERMER Christof**
*/


/* 
BEFEHLE 
Befelsform:
Kommando,u16Val-1,u16Val-2<13>  <13>  //<13> = CR = \r = 13
Bsp:
Motor,123,34<CR>
Ping<CR>
GetSW>CR>

Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Befehle in diese Datei ausgelagert.
*/

#include <stdint.h> 
#include <ctype.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>

#include "main.h"
#include "softuart.h"
#include "SWU_Befehle.h"
#include "debug.h"


/*
EIne Besonderheit des AVR Mikrocontrollers ist die unterschiedliche Behandlung von Zeichen=Strings, 
die entweder im Flash-Speicher  Stehen, und somit von dort gelesen werden,
oder die im RAM stehen,
Es gibt also also C-Funktionen die Strings behandeln doppelt.
einmal mit "Programm Memory Handling" und
quasi Normal: ohne besonderen, dafr RAM-Verbrauchende Stringbehandlung.

Hier liegt musterglitig ein "const cahr" string , d
der aber im "Programm-Flash" abgespeichert wird und nicht im "RAM".
*/

//	\r return
//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator

//Prototype
// GLOBALE VARIABLEN
// CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
// const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#ifdef SW_UART_USE_ENABLED
char gcaStr[STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0
#endif 


#ifdef SW_UART_USE_ENABLED
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
#endif
SW_COMMAND_TYPE gsCmd; // Hier liegen die Befehle und Parameter ab

//Rckgabevariablen
//unsigned int u16Value;		// UINT 16 Bit

#ifdef SW_UART_USE_ENABLED
//CONSTANTEN
//const char MCA_TRENNLINIE[] PROGMEM = "-------------\r";
//const char MCA_PORTX[] PROGMEM	= " x=B,C,D\r";
#endif


#ifdef SW_UART_USE_ENABLED
// *********************************
void SW_CheckOrder(void) //von gcaRxStr
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"

//========================
SW_TokensRXStr(gcaRxStr);
//========================
SW_ResetRxBuff();
//========================
 
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	softuart_puts_p( PSTR("PONG\r") );	
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))  // GET
	{
	softuart_puts_p( PSTR("UNO-R3\r") );
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TT"))) //TICKS anzeigen
	{
	softuart_puts( ultoa( gu32_Ticks, gcaNumStr, 10 ) );
	softuart_putchar( 13 ); //CR
	return;
	}


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TO")))	// Flags Setzen 
	{
	gu8Status |= STATUS_TRIGGER_OUTPUT;
	return;
	}

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TF"))) // Flags lschen
	{
	gu8Status &= ~STATUS_TRIGGER_OUTPUT;
	return;
	}		

 }; // ORDER
#endif //SW_UART_USE_ENABLED


#ifdef SW_UART_USE_ENABLED
// **************************
void SW_ResetRxBuff(void)
// **************************
{
softuart_flush_input_buffer();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef SW_UART_USE_ENABLED
//Funktionen Definition
// *******************************************************************
void SW_UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
char cGetRxC;
if( softuart_kbhit() )
	{
	cGetRxC = softuart_getchar();

//STrzt ab damit
//softuart_putchar( cGetRxC);
//softuart_putchar( 13 );
//   * new data available from UART
if( gu8Status & STATUS_ORDER_EVENT ) // Schon wa szu tun, 
	{
	return;
	};

	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( cGetRxC )
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: ////Check CR order
				{
				gu8Status |= STATUS_ORDER_EVENT;
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with  Parser
				*gpcRxPars++ = cGetRxC;//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				break;
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{//overflow of RX clears all
		SW_ResetRxBuff();
		};
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif // SW_UART_USE_ENABLED

#ifdef SW_UART_USE_ENABLED
/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void SW_TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
const char  caDelimiter[]= ",";
char * pStrTok; // fr strtok_r
//char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*
//char * 	strtok_r (char *, const char *, char **)
//char * 	strtok (char *, const char *)
//if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
if( (pStrTok = strtok( pcStrOrder, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommand
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};	
};
#endif

