

/*
SW UART
PORTB PB0= SOFTUART_RXBIT	-->	PIN 8 ARDUINO
PORTB PB1= SOFTUART_TXBIT	--> PIN 9 ARDUINO
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"SW UART + Mnenomic"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"09.05.2017 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>

#include <stdio.h>

#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart_328p.h"
#include "softuart.h"

//#include "crc16.h"
#include "SWU_Befehle.h"
#include "debug.h"

//#include "./BSP/bsp_defs.h"
#include "./EFMSrc/RadioDefs.h"
#include "./EFMSrc/iM880A_RadioInterface.h"


// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
volatile static uint8_t u8RXLook;

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_1000MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
if( ( (u8RXLook++) > 6 ) ) // Langsamer nachsehen 
	{	
	u8RXLook ^= u8RXLook;
	SW_UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
	};

};




// *************
int main(void)
// *************
{
volatile uint32_t u32_MainLoopDiff;	 //  T2 TimerCounter

DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

wdt_reset();   //WATCHDOG!
//wdt_enable(5); //500mS Totmannknopf

softuart_init();
softuart_turn_rx_on(); /* redundant - on by default */
softuart_flush_input_buffer();
sei();

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
SW_ResetRxBuff();


//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrupt aktivieren

sei();

uart_puts_p("115200 UART ist da") ;uart_putc( 13 ); //CR
softuart_puts_p( PSTR( "SWUART ist da" ));softuart_putchar(13);; //CR
Toggle_Bit(4);
softuart_putchar(65); 
Toggle_Bit(5);
softuart_putchar(13); 

softuart_puts_p( PSTR( HARDWARE )); softuart_putchar(13); 

softuart_puts_p(  PSTR( SOFTWARE ) );softuart_putchar(13);
softuart_puts_p( PSTR( DATUM )  );softuart_putchar(13); 
softuart_puts_p( PSTR( AUTOR ) );softuart_putchar(13); 
softuart_puts_p( PSTR( IHAVENOBRAIN ) );softuart_putchar(13); 
softuart_puts_p( PSTR( USEYOURS ) );softuart_putchar(13); 

gu8Status |= STATUS_TRIGGER_OUTPUT;

sei();
while(1)  //ENSLESS
	{
	wdt_reset();	//WATCHDOG!
Toggle_Bit(1);
	u32_MainLoopDiff++;

	if( gu8Status & STATUS_ORDER_EVENT ) //TO/TF
		{
		SW_CheckOrder();//gcaRxStr = accumulated str
		SW_ResetRxBuff();
		gu8Status &= ~STATUS_ORDER_EVENT;
		};

	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action		
	

		if( gu8Status & STATUS_TRIGGER_OUTPUT ) //TO/TF
			{
Toggle_Bit(2);			
			ultoa( u32_MainLoopDiff, gcaNumStr, 10 );
			u32_MainLoopDiff ^= u32_MainLoopDiff;;
		
			//softuart_puts_p(  PSTR( "T:") );
			// ultoa( gu32_Ticks, gcaNumStr, 10 );			
			uart_puts_p("115200 UART ist da") ;uart_putc( 13 ); //CR

			softuart_puts(  gcaNumStr );
			softuart_putchar( 13 ); //CR
			
/*			uart_puts_p( PSTR("T2:") );
			uart_puts( gcaNumStr ); 
			uart_putc( 13 ); //CR
*/
			};


		};
	};
}; // main
